// sig1.cpp
// Glenn G. Chappell
// 15 Feb 2013
//
// For CS 321 Spring 2013
// Signal handler demo

#include <iostream>
using std::cout;
using std::endl;
#include <signal.h>  // for signal, SIGINT


volatile char c = 'A';  // Char to print; altered by handler


// handler
// Signal handler
// Prints message and bumps up global count
void handler(int i)  // param is which signal 
{
    cout << "********** Bumping up char" << endl;
    ++c;
}


// main
// Install handler for SIGINT, slowly prints increasing numbers
int main()
{
    // Set up signal handler for SIGINT (sent by ctrl-C in *ix)
    signal(SIGINT, handler);

    while (true)
    {
        // Count up for a while, slowly
        for (int count = 0; count < 1000000000; ++count)
        {
            cout << "Hit ctrl-C!    c = '" << c
                 << "'    count = " << count << endl;
            for (volatile int k = 0; k < 30000000; ++k) ;
                // "volatile" so no optimizing out our delay loop
        }
    }

    return 0;
}

